# -*- coding: utf-8 -*-
#
# Zimbra Corporation Server 4 UCS
#
# Copyright 2016-2017 Univention GmbH
#
# http://www.univention.de/
#
# All rights reserved.
#
# The source code of this program is made available
# under the terms of the GNU Affero General Public License version 3
# (GNU AGPL V3) as published by the Free Software Foundation.
#
# Binary versions of this program provided by Univention to you as
# well as other copyrighted, protected or trademarked materials like
# Logos, graphics, fonts, specific documentations and configurations,
# cryptographic keys etc. are subject to a license agreement between
# you and Univention and not subject to the GNU AGPL V3.
#
# In the case you use this program under the terms of the GNU AGPL V3,
# the program is provided in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License with the Debian GNU/Linux or Univention distribution in file
# /usr/share/common-licenses/AGPL-3; if not, see
# <http://www.gnu.org/licenses/>.

from univention.lib.i18n import Translation

_ = Translation('univention-zimbra').translate


class ZimbraError(Exception):
	pass


class ZimbraConnectionFailed(ZimbraError):
	pass


class ZimbraAuthenticationFailed(ZimbraError):
	pass


class ZimbraResponseEmpty(ZimbraError):
	pass


class ZimbraNotInitialized(ZimbraError):
	pass


class ZimbraResponseError(ZimbraError):

	def __init__(self, msg, code):
		self.msg = msg
		self.code = code
		super(ZimbraResponseError, self).__init__(msg, code)

	def __str__(self):
		return _('Response failed: %s (code: %s)') % (self.msg, self.code)


class ZimbraObjectAlreadyExists(ZimbraResponseError):
	pass


class ZimbraNoSuchObject(ZimbraResponseError):
	pass
